#include <iostream>
using namespace std;

#define QUE_SIZE 100

class que{
	int memory[QUE_SIZE];
	int top;
	int tail;
public:
	que();
	void enque(int data);
	int deque();
};

que::que()
{
	top = 0;
	tail = 0;
}
void que::enque(int data)
{
	memory[top++] = data;
	top = top % QUE_SIZE;
}
int que::deque()
{
	int ret = memory[tail++];
	tail = tail % QUE_SIZE;
	return ret;
}

int main(){
	que q1;
		
	q1.enque(0);
	for (int i = 0; i < 40; i++){
		q1.enque(i*3+1);
		q1.enque(i*3+2);
		q1.enque(i*3+3);
		cout << q1.deque() << " " << q1.deque() << " " << q1.deque() << "\n";
	}
	
	return 0;
}